package circlePuzzles.data;

import java.util.ArrayList;
import java.util.Collections;

import circlePuzzles.grid.Grid;

public class CircleList
extends ArrayList<Circle>
{
   public void toggle(Circle c2){
      int i = indexOf(c2);
      if( i>=0 ){
         remove(i);
      }else{
         add(new Circle(c2));
         Collections.sort(this);
      }
   }
   private Circle temp = new Circle();
   public boolean contains(int x, int y, int t, int n, int r){
      temp.set(x,y,t,n,r);
      return contains(temp);
   }
   public void doMove(Grid grid, Circle move){
      for( Circle c : this ){
         grid.rotate(move,c);
      }
   }

   public String getString(){
      StringBuffer sb=new StringBuffer();
      for( Circle c : this ){
         sb.append(c.getString()+" ");
      }
      return sb.toString();
   }
   public String toString(){
      StringBuffer sb=new StringBuffer();
      for( Circle c : this ){
         sb.append(c.toString()+" ");
      }
      return sb.toString();
   }
   public int getValence(Grid grid){
      int v=1;
      for( Circle c : this ){
         int w = grid.getOrder(c.getT());
         v = v*w/gcd( v,w );
      }
      return v;
   }
   private int gcd( int a, int b ){
      if( a<0 ) return -gcd(-a,b);
      if( b<0 ) return gcd(a,b);
      if( a==0 ) return b;
      if( b==0 ) return a;
      if( (a&1)==0 && (b&1)==0 ) return gcd( a>>1,b>>1)<<1;
      return (a>b) ? gcd(a-b,b) : gcd(a, b-a);
   }
}
