package circlePuzzles.data;

import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;

import circlePuzzles.grid.Grid;
public class Move
{
   static public final int STEPS = 10;
   private AffineTransform transform;
   private AffineTransform invTransform;
   private AffineTransform animTransform;
   private Circle circle;
   private int id;
   private int order;
   public Move( int i, Circle c, Grid g, boolean d){
      id = i;
      circle = new Circle(c);
      order = (d?1:-1) * g.getOrder(circle.getT());
      double angle = 2*Math.PI / order;
      Point2D pp1 = g.getCentre(c, null);
      transform = AffineTransform.getRotateInstance( angle, pp1.getX(), pp1.getY());
      invTransform = AffineTransform.getRotateInstance( -angle, pp1.getX(), pp1.getY());
      animTransform = AffineTransform.getRotateInstance( angle/STEPS, pp1.getX(), pp1.getY());
   }
   public AffineTransform getTransform(){return transform;}
   public AffineTransform getInvTransform(){return invTransform;}
   public AffineTransform getAnimTransform(){return animTransform;}
   public int getId(){return id;}
   public int getOrder(){return order;}
   public Circle getCircle(){ return circle; }
   public String getString(){
      return id+":"+circle.getString();
   }
}
