package circlePuzzles.grid;

import java.awt.Point;
import java.awt.geom.Point2D;

import circlePuzzles.data.Circle;
public class GridHexagonal
extends Grid
{
   public GridHexagonal(){
      super("(6) Hexagonal", new int[]{1}, new int[]{6} );
   }
   final static double hlfRt3 = Math.sqrt(3)/2; 
   public Point2D getCentre(int x, int y, int t, int n, Point2D p0){
      Point2D p = p0 ==null ? new Point2D.Double() : p0;
      p.setLocation(x-0.5*y,y*hlfRt3);
      return p; 
   }
   public Point getNearestCentre(double x, double y, int t, int n, Point p0){
      Point p = p0 ==null ? new Point() : p0;
      p.y=(int)Math.floor(y/hlfRt3+.5);
      p.x=(int)Math.floor((x+0.5*p.y) +.5);
      return p;
   } 
   public void rotate(Circle centre, Circle circle){
      int x0 = circle.getX() - centre.getX();
      int y0 = circle.getY() - centre.getY();
      int x1 = x0-y0;
      int y1 = x0;
      circle.set(x1+centre.getX(),y1+centre.getY(),0, 0);
   }
}
