package circlePuzzles.grid;

import java.awt.Point;
import java.awt.geom.Point2D;

import circlePuzzles.data.Circle;
public class GridTriHex
extends Grid
{
   public GridTriHex(){
      super("(632) Tri-Hex Full", new int[]{1,2,3}, new int[]{6,3,2});
   }
   final static double hlfRt3 = Math.sqrt(3)/2; 

   public Point2D getCentre(int x, int y, int t, int n, Point2D p0){
      Point2D p = p0 ==null ? new Point2D.Double() : p0;
      if( t==0 ){
         p.setLocation(x-0.5*y,y*hlfRt3);
      }else if( t==1 ){
         if( n==0 ){
            p.setLocation(x-0.5*y+.5,(y+(1/3.0))*hlfRt3);
         }else{
            p.setLocation(x-0.5*y+.5,(y-(1/3.0))*hlfRt3);
         }
      }else if( t==2 ){
         if( n==0 ){
            p.setLocation(x-0.5*y+0.5,y*hlfRt3);
         }else if(n==1){
            p.setLocation(x-0.5*y+0.25,(y-0.5)*hlfRt3);
         }else{
            p.setLocation(x-0.5*y+0.25,(y+0.5)*hlfRt3);
         }
      }
      return p; 
   }
   public Point getNearestCentre(double x, double y, int t, int n, Point p0){
      Point p = p0 ==null ? new Point() : p0;
      if( t==0 ){
         p.y=(int)Math.floor(y/hlfRt3+.5);
         p.x=(int)Math.floor((x+0.5*p.y) +.5);
      }else if( t==1 ){
         if( n==0 ){
            p.y=(int)Math.floor(y/hlfRt3+(-1/3.0+.5));
            p.x=(int)Math.floor(x+0.5*p.y);
         }else{
            p.y=(int)Math.floor(y/hlfRt3+(1/3.0+.5));
            p.x=(int)Math.floor(x+0.5*p.y);
         }
      }else if( t==2 ){
         if( n==0 ){
            p.y=(int)Math.floor(y/hlfRt3+.5);
            p.x=(int)Math.floor(x+0.5*p.y);
         }else if(n==1){
            p.y=(int)Math.floor(y/hlfRt3+1);
            p.x=(int)Math.floor(x+0.5*p.y+0.25);
         }else{
            p.y=(int)Math.floor(y/hlfRt3);
            p.x=(int)Math.floor(x+0.5*p.y+0.25);
         }
      }
      return p;
   } 
   public void rotate(Circle centre, Circle circle){
      int x0 = circle.getX() - centre.getX();
      int y0 = circle.getY() - centre.getY();
      int x1=0, y1=0, n1=circle.getN();
      if( centre.getT()==0 ){
         x1=x0-y0; y1=x0;
         if      ( circle.getT()==1 ){
            if( n1==0) { n1=1; y1++; }
            else n1=0;
         }else if( circle.getT()!=0 ){
            if     ( n1==0 )   n1=2;
            else if( n1==1 )   n1=0;
            else if( n1==2 ) { n1=1; y1++; }
         }
      }else if( centre.getT()==1 ){
         x1=-y0; y1=x0-y0;
         if( centre.getN()==0 ){
            if     ( circle.getT()==0 ) x1++;
            else if( circle.getT()==1 ){
               if( n1==1) { x1++; y1++; }
            }else{
               if     ( n1==0 ){ n1=1; x1++; y1++; }
               else if( n1==1 ){ n1=2; x1++; } 
               else if( n1==2 )  n1=0;
            }
         }else{
            if     ( circle.getT()==0 ) y1--;
            else if( circle.getT()==1 ){
               if( n1==0) { x1--; y1--; }
            }else{
               if     ( n1==0 )  n1=1;
               else if( n1==1 ){ n1=2; y1--; } 
               else if( n1==2 ){ n1=0; x1--; y1--;}
            }
         }
      }else{
         x1=-x0; y1=-y0;
         if( centre.getN()==0 ){
            if     ( circle.getT()==0 ) x1++;
            else if( circle.getT()==1 ) n1=1-n1;
            else{
               if     ( n1==1 ){ x1++; y1++; } 
               else if( n1==2 ){ y1--; }
            }
         }else if( centre.getN()==1 ){
            if     ( circle.getT()==0 ) y1--;
            else if( circle.getT()==1 ) {
               if( n1==0 ){ n1=1; x1--;y1--; }
               else { n1=0; x1--;y1--; }
            }else{
               if     ( n1==0 ){ x1--; y1--; }
               else if( n1==2 ){ y1-=2; x1--; }
            }
         }else{
            if     ( circle.getT()==0 ) { x1++; y1++;} 
            else if( circle.getT()==1 ) {
               if( n1==0 ){ n1=1; y1++; }
               else { n1=0; y1++; }
            }else{
               if     ( n1==0 ){ y1++; }
               else if( n1==1 ){ y1+=2; x1++; }
            }
         }
      }
      circle.set(x1+centre.getX(), y1+centre.getY(), circle.getT(), n1);
   }
}
