package circlePuzzles.grid;

import java.awt.Point;
import java.awt.geom.Point2D;

import circlePuzzles.data.Circle;
public class GridTriTriangular
extends Grid
{
   public GridTriTriangular(){
      super("(333) Tri-triangular", new int[]{1,1,1}, new int[]{3,3,3});
   }
   final static double hlfRt3 = Math.sqrt(3)/2;
   public Point2D getCentre(int x, int y, int t, int n, Point2D p0){
      Point2D p = p0 ==null ? new Point2D.Double() : p0;
      if( t==0 ){
         p.setLocation(x*1.5,(y*2-x)*hlfRt3);
      }else if( t==1 ){
         p.setLocation(x*1.5+0.5,(y*2-x-1)*hlfRt3);
      }else{
         p.setLocation(x*1.5+1,(y*2-x)*hlfRt3);
      }
      return p;
   }
   public Point getNearestCentre(double x, double y, int t, int n, Point p0){
      Point p = p0 ==null ? new Point() : p0;
      if( t==0 ){
         p.x=(int)Math.floor(x/1.5 +.5);
         p.y=(int)Math.floor((y/hlfRt3+p.x)/2+.5);
      }else if( t==1 ){
         p.x=(int)Math.floor((x-0.5)/1.5 +.5);
         p.y=(int)Math.floor((y/hlfRt3+p.x+1)/2+.5);
      }else{
         p.x=(int)Math.floor((x-1.0)/1.5 +.5);
         p.y=(int)Math.floor((y/hlfRt3+p.x)/2+.5);
      }
      return p;
   }
   public void rotate(Circle centre, Circle circle){
      int x0 = circle.getX() - centre.getX();
      int y0 = circle.getY() - centre.getY();
      int x1= -y0, y1 = x0-y0;
      if( centre.getT()==0 ){
         if     ( circle.getT()==1 ) y1++;
         else if( circle.getT()==2 ) x1--; 
      }else if( centre.getT()==1 ){
         if     ( circle.getT()==0 ) y1--;
         else if( circle.getT()==2 ) { x1--; y1--; }
      }else if( centre.getT()==2 ){
         if     ( circle.getT()==0 ) x1++;
         else if( circle.getT()==1 ) {x1++; y1++;}
      }
      circle.set(x1+centre.getX(),y1+centre.getY(),circle.getT(),circle.getN());
   }
}
