package circlePuzzles.gui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Image;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.JButton;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JTextField;

import circlePuzzles.CirclePuzzles;
import circlePuzzles.data.Puzzle;

public final class TabPlay extends MyTab
implements ActionListener
{
   private PanelPlay playPanel;
   private JButton mixButton, resetButton;
   private JTextField description = new JTextField();

   public TabPlay (Puzzle puz, Image pi){
      super(puz, "Play", "Play the puzzle");

      description.setEditable(false);

      playPanel = new PanelPlay(puz,pi);

      mixButton = new JButton("Mix");
      mixButton.addActionListener(this);
      resetButton = new JButton("Reset");
      resetButton.addActionListener(this);

      JPanel controlPanel = new JPanel();
      controlPanel.setLayout(new BoxLayout(controlPanel, BoxLayout.X_AXIS));
      controlPanel.add(Box.createHorizontalGlue());
      controlPanel.add(mixButton);
      controlPanel.add(resetButton);

      JLabel text = new JLabel("Play with the puzzle. Click and drag pieces to move them.");
      JPanel southPanel = new JPanel(new BorderLayout());
      southPanel.add(text,BorderLayout.WEST);
      southPanel.add(controlPanel,BorderLayout.SOUTH);

      setLayout(new BorderLayout());
      add(description, BorderLayout.NORTH);
      add(playPanel);
      add(southPanel, BorderLayout.SOUTH);

   }
   protected void init(){
      description.setText(puz.getDescription());
      playPanel.init();
   }
   protected void exit(){
   }
   public void initColours(){
      Color edgeColour = CirclePuzzles.settingsManager.getColorSetting(CirclePuzzles.settingKeyEdgeColour);
      Color selectedEdgeColour = CirclePuzzles.settingsManager.getColorSetting(CirclePuzzles.settingKeyEdgeSelectionColour);
      playPanel.setColours(edgeColour, selectedEdgeColour);
   }
   public void actionPerformed(ActionEvent ae){
      if( ae.getSource()==resetButton ){
         playPanel.reset();
      }else if( ae.getSource()==mixButton ){
         playPanel.mix();
      }
   }
}